--- old/usr/src/uts/common/fs/zfs/dmu_tx.c	Thu Aug 15 17:43:56 2013
+++ new/usr/src/uts/common/fs/zfs/dmu_tx.c	Thu Aug 15 17:43:56 2013
@@ -615,7 +615,8 @@
 	 * if they are blocksize-aligned.
 	 */
 	if (dn->dn_datablkshift == 0) {
-		dmu_tx_count_write(txh, off, len);
+		if (off != 0 || len < dn->dn_datablksz)
+			dmu_tx_count_write(txh, off, len);
 	} else {
 		/* first block will be modified if it is not aligned */
 		if (!IS_P2ALIGNED(off, 1 << dn->dn_datablkshift))
